## goldendict-ng 23.07.25

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25) # ubuntu 23.04 Fedora 36

# Qt6.4+ only

option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
option(WITH_XAPIAN "enable Xapian support" ON)
option(WITH_ZIM "enable zim support" ON)

# options for linux packaging
option(USE_SYSTEM_FMT "use system fmt instead of bundled one" OFF)
option(USE_SYSTEM_TOML "use system toml++ instead of bundled one" OFF)

include(FeatureSummary)

project(goldendict-ng
        VERSION 23.07.25
        LANGUAGES CXX C)

set(GOLDENDICT "goldendict") # binary/executable name

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#### Importing Libraries

find_package(Qt6 REQUIRED COMPONENTS
        Concurrent
        Core5Compat
        LinguistTools
        Multimedia
        WebEngineWidgets
        Widgets
        Svg
        Xml
        TextToSpeech
        )

#### Compile time files and preprocessor flags

# Obtain git commit hash
execute_process(
        COMMAND git rev-parse --short=8 HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE GIT_HASH
        OUTPUT_STRIP_TRAILING_WHITESPACE
)

string(TIMESTAMP date_for_version_file) # note: this variable is cached for every run, but for user installation, this doesn't matter much
configure_file(version.txt.in ${CMAKE_SOURCE_DIR}/version.txt)

#### Sources Files

# auto discovery of ui files https://cmake.org/cmake/help/v3.26/prop_tgt/AUTOUIC_SEARCH_PATHS.html
set(CMAKE_AUTOUIC_SEARCH_PATHS "${CMAKE_CURRENT_SOURCE_DIR}/src/ui/")

# https://cmake.org/cmake/help/latest/command/file.html#filesystem
# ! Using GLOB_RECURSE is not recommended by cmake's documentation
# CONFIGURE_DEPENDS will trigger file tree recheck in every rebuilds.
file(GLOB_RECURSE ALL_SOURCE_FILES CONFIGURE_DEPENDS src/*.cc src/*.hh src/*.c)

if (APPLE)
    file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
endif ()

set(QSINGLEAPP_SOURCE_FILES
        thirdparty/qtsingleapplication/src/qtlocalpeer.cpp
        thirdparty/qtsingleapplication/src/qtlocalpeer.h
        thirdparty/qtsingleapplication/src/qtsingleapplication.cpp
        thirdparty/qtsingleapplication/src/qtsingleapplication.h
        )

qt_add_executable(${GOLDENDICT} MANUAL_FINALIZATION)

target_sources(${GOLDENDICT} PRIVATE
        icons/flags.qrc
        resources.qrc
        src/scripts/scripts.qrc
        src/stylesheets/css.qrc
        ${ALL_SOURCE_FILES}
        ${MACOS_SOURCE_FILES}
        ${QSINGLEAPP_SOURCE_FILES})

if (NOT USE_SYSTEM_FMT)
    target_sources(${GOLDENDICT} PRIVATE thirdparty/fmt/format.cc)
endif ()

### Common parts amount all platforms

# Note: used as c++ string thus need surrounding " "
add_compile_definitions(PROGRAM_VERSION="${PROJECT_VERSION}")

if (LINUX)
    # see: config.cc -> getProgramDataDir
    add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict")
endif ()

target_link_libraries(${GOLDENDICT} PRIVATE
        Qt6::Xml
        Qt6::Concurrent
        Qt6::Core5Compat
        Qt6::Multimedia
        Qt6::WebEngineWidgets
        Qt6::Widgets
        Qt6::Svg
        Qt6::TextToSpeech
        )


target_include_directories(${GOLDENDICT} PRIVATE
        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
        ${PROJECT_SOURCE_DIR}/src/
        ${PROJECT_SOURCE_DIR}/src/common
        ${PROJECT_SOURCE_DIR}/src/dict
        ${PROJECT_SOURCE_DIR}/src/ui
        )

if (NOT USE_SYSTEM_TOML)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/tomlplusplus)
endif ()

if (NOT USE_SYSTEM_FMT)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/fmt/include)
endif ()

#### Compile definitions

target_compile_definitions(${GOLDENDICT} PUBLIC
        CMAKE_USED_HACK  # temporal hack to avoid breaking qmake build
        USE_ICONV
        MAKE_QTMULTIMEDIA_PLAYER
        MAKE_CHINESE_CONVERSION_SUPPORT
        )

if (WITH_FFMPEG_PLAYER)
    target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_FFMPEG_PLAYER)
endif ()


if (NOT WITH_EPWING_SUPPORT)
    target_compile_definitions(${GOLDENDICT} PUBLIC NO_EPWING_SUPPORT)
endif ()


if (WITH_XAPIAN)
    target_compile_definitions(${GOLDENDICT} PUBLIC USE_XAPIAN)
endif ()

if (WITH_ZIM)
    target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_ZIM_SUPPORT)
endif ()

#### libraries linking && includes for Win or Unix

if (WIN32)
    include(CMake_Win.cmake)
else ()
    include(CMake_Unix.cmake)
endif ()

#### add translations

install(TARGETS ${GOLDENDICT}
        BUNDLE DESTINATION .
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/${GOLDENDICT})

# include all *ts files under locale
file(GLOB TRANS_FILES "locale/*.ts")

# Put generated files to output dir's locale
set_source_files_properties(${TRANS_FILES}
        PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/locale")

# a wrapper over qt_add_lupdate and  qt_add_lrelease
qt_add_translations(${GOLDENDICT} TS_FILES ${TRANS_FILES}
        QM_FILES_OUTPUT_VARIABLE qm_files)

#### installation

if (APPLE)
    set_target_properties(${GOLDENDICT} PROPERTIES
            MACOSX_BUNDLE_GUI_IDENTIFIER my.example.com
            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            MACOSX_BUNDLE TRUE
            )
endif ()

if (LINUX OR BSD)
    install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop DESTINATION share/applications)
    install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.metainfo.xml DESTINATION share/metainfo)

    install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps)

    install(FILES ${qm_files} DESTINATION share/goldendict/locale)
endif ()

qt_finalize_target(${GOLDENDICT})

feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-ng (23.07.25-1build1) mantic; urgency=medium

  * Rebuild against new libavcodec60.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jul 2023 22:21:59 +0200

goldendict-ng (23.07.25-1) unstable; urgency=medium

  * New upstream release 23.07.25-alpha.230725.d3e60184.
  * debian/control: Drop unnecessary build-dep libao-dev, libtiff-dev.
  * debian/patches: Drop merged patch.

 -- Boyuan Yang <byang@debian.org>  Tue, 25 Jul 2023 18:41:02 -0400

goldendict-ng (23.06.02-1) unstable; urgency=medium

  * New upstream release 23.06.02-alpha.230702.d2fbacdd.
  * Switch to CMake buildsystem.
  * debian/copyright: Update according to upstream source changes.
  * debian/rules: Use Qt6 build. (Closes: #1028397)
  * debian/control: Update build-dependency accordingly.
  * debian/patches/0002-Fix-zh_CN-translation.patch: Add interim patch for
    zh_CN translation error.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Jul 2023 21:47:02 -0400

goldendict-ng (23.02.05-2) unstable; urgency=medium

  * No change source and binary package rename following upstream
    renaming and recommendation.
  * debian/control:
    + Update to latest upstream Homepage field.
    + Update package replacement relationship accordingly.
    + Replace package: libtiff5-dev => libtiff-dev.

 -- Boyuan Yang <byang@debian.org>  Tue, 20 Jun 2023 11:16:52 -0400

goldendict-webengine (23.02.05-1) unstable; urgency=medium

  * New upstream release 23.02.06-LanternFestival.230205.9b8f85ca.
  * debian/rules: Enable use_iconv flag.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Feb 2023 21:02:13 -0500

goldendict-webengine (22.12.20-1) unstable; urgency=medium

  * New upstream release 22.12.22-WinderSolstice.221220.311d08c6.
  * debian/patches: Add patch to disable new version check by default.

 -- Boyuan Yang <byang@debian.org>  Wed, 21 Dec 2022 16:32:44 -0500

goldendict-webengine (22.11.24-alpha.221205.45d740a5-2) unstable; urgency=medium

  * Source-only upload.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Dec 2022 15:27:27 -0500

goldendict-webengine (22.11.24-alpha.221205.45d740a5-1) unstable; urgency=medium

  * Initial release. (Closes: #1024862)
  * debian/copyright: Update icons copyright information.

 -- Boyuan Yang <byang@debian.org>  Tue, 06 Dec 2022 16:12:46 -0500

=== debian/control ===
Source: goldendict-ng
Priority: optional
Section: utils
Maintainer: Boyuan Yang <byang@debian.org>
Standards-Version: 4.6.2
Build-Depends:
 cmake (>= 3.25),
 debhelper-compat (= 13),
 libavformat-dev,
 libavutil-dev,
 libbz2-dev,
 libeb16-dev,
 libfmt-dev,
 libhunspell-dev,
 libjs-jquery,
 liblzma-dev,
 liblzo2-dev,
 libopencc-dev (>= 1.1),
 libtomlplusplus-dev,
 libvorbis-dev,
 libx11-dev,
 libxtst-dev,
 libzim-dev,
 libzstd-dev,
 pkg-config,
 qt6-5compat-dev,
 qt6-base-dev,
 qt6-multimedia-dev,
 qt6-speech-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-webchannel-dev,
 qt6-webengine-dev,
 x11proto-record-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Homepage: https://github.com/xiaoyifang/goldendict-ng
Vcs-Browser: https://salsa.debian.org/debian/goldendict-ng
Vcs-Git: https://salsa.debian.org/debian/goldendict-ng.git

Package: goldendict-ng
Architecture: any
Depends:
 libjs-jquery,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 goldendict,
 goldendict-webengine,
Replaces:
 goldendict,
 goldendict-webengine,
Provides:
 goldendict,
 goldendict-webengine,
Description: feature-rich dictionary lookup program (NG/qtwebengine fork)
 GoldenDict is a feature-rich dictionary lookup program, supporting multiple
 dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
 and online dictionaries, featuring perfect article rendering with the
 complete markup, illustrations and other content retained,
 and allowing you to type in words without any accents or correct case.
 .
 This is a forked version that uses QtWebEngine as rendering engine instead
 of QtWebKit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := 6

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DWITH_XAPIAN=ON \
	        -DWITH_ZIM=ON \
	        -DWITH_FFMPEG_PLAYER=ON \
	        -DWITH_EPWING_SUPPORT=ON \
	        -DUSE_SYSTEM_FMT=ON \
	        -DUSE_SYSTEM_TOML=ON \
	        $(NULL)

execute_before_dh_auto_configure:
	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/xiaoyifang/goldendict-ng/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## goldendict-ng 23.12.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,27 +6,35 @@
 option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
 option(WITH_XAPIAN "enable Xapian support" ON)
 option(WITH_ZIM "enable zim support" ON)
+option(WITH_TTS "enable QTexttoSpeech support" ON)
 
 # options for linux packaging
 option(USE_SYSTEM_FMT "use system fmt instead of bundled one" OFF)
 option(USE_SYSTEM_TOML "use system toml++ instead of bundled one" OFF)
 
+## Change binary & resources folder to parallel install with original GD.
+## This flag should be avoided because it leads to small regressions:
+## 1. There are personal scripts assuming the binary name to be "goldendict" -> require everyone to change the name in their script
+## 2. There are icon themes that assuming the icon name to be "goldendict" -> invalidate the GD icon when using a icon theme
+## 3. There are dictionary packages that install files to "/usr/share/goldendict/content" -> nullify the auto dict discovery
+option(USE_ALTERNATIVE_NAME "Force the name goldendict-ng " OFF)
+
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 23.07.25
+        VERSION 23.12.08
         LANGUAGES CXX C)
 
-set(GOLDENDICT "goldendict") # binary/executable name
-
-set(CMAKE_AUTOUIC ON)
-set(CMAKE_AUTOMOC ON)
-set(CMAKE_AUTORCC ON)
+if (NOT USE_ALTERNATIVE_NAME)
+    set(GOLDENDICT "goldendict") # binary/executable name
+else ()
+    set(GOLDENDICT "goldendict-ng")
+endif ()
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-#### Importing Libraries
+#### Qt
 
 find_package(Qt6 REQUIRED COMPONENTS
         Concurrent
@@ -40,18 +48,30 @@
         TextToSpeech
         )
 
-#### Compile time files and preprocessor flags
-
-# Obtain git commit hash
-execute_process(
-        COMMAND git rev-parse --short=8 HEAD
-        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
-        OUTPUT_VARIABLE GIT_HASH
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-)
-
-string(TIMESTAMP date_for_version_file) # note: this variable is cached for every run, but for user installation, this doesn't matter much
-configure_file(version.txt.in ${CMAKE_SOURCE_DIR}/version.txt)
+qt_standard_project_setup() # availiable after find_package(Qt6 .... Core
+set(CMAKE_AUTORCC ON) # not included in the qt_standard_project_setup
+
+#### Things required during configuration
+
+block() # generate version.txt
+    string(TIMESTAMP build_time)
+    find_package(Git)
+    if (EXISTS "${CMAKE_SOURCE_DIR}/.git" AND GIT_FOUND)
+        execute_process(
+                COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_SOURCE_DIR}" rev-parse --short HEAD
+                OUTPUT_STRIP_TRAILING_WHITESPACE
+                OUTPUT_VARIABLE GIT_HASH)
+        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION}.${GIT_HASH} at ${build_time}")
+    else () # not built in a git repo
+        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION} at ${build_time}")
+    endif ()
+endblock()
+
+if (WIN32)
+    # Binaries output dir for windows. The default ${CMAKE_BINARY_DIR} is too messy, use subfolder instead
+    # So that we can directly use windeployqt inside the output folder and obtain a redistributable GD
+    set(GD_WIN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/${GOLDENDICT})
+endif ()
 
 #### Sources Files
 
@@ -65,6 +85,10 @@
 
 if (APPLE)
     file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
+endif ()
+
+if (WIN32)
+    set(WINDOWS_ICON_RC icons/programicon.rc)
 endif ()
 
 set(QSINGLEAPP_SOURCE_FILES
@@ -72,9 +96,9 @@
         thirdparty/qtsingleapplication/src/qtlocalpeer.h
         thirdparty/qtsingleapplication/src/qtsingleapplication.cpp
         thirdparty/qtsingleapplication/src/qtsingleapplication.h
-        )
-
-qt_add_executable(${GOLDENDICT} MANUAL_FINALIZATION)
+)
+
+qt_add_executable(${GOLDENDICT})
 
 target_sources(${GOLDENDICT} PRIVATE
         icons/flags.qrc
@@ -83,7 +107,9 @@
         src/stylesheets/css.qrc
         ${ALL_SOURCE_FILES}
         ${MACOS_SOURCE_FILES}
-        ${QSINGLEAPP_SOURCE_FILES})
+        ${QSINGLEAPP_SOURCE_FILES}
+        ${WINDOWS_ICON_RC}
+)
 
 if (NOT USE_SYSTEM_FMT)
     target_sources(${GOLDENDICT} PRIVATE thirdparty/fmt/format.cc)
@@ -93,11 +119,6 @@
 
 # Note: used as c++ string thus need surrounding " "
 add_compile_definitions(PROGRAM_VERSION="${PROJECT_VERSION}")
-
-if (LINUX)
-    # see: config.cc -> getProgramDataDir
-    add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict")
-endif ()
 
 target_link_libraries(${GOLDENDICT} PRIVATE
         Qt6::Xml
@@ -140,6 +161,10 @@
     target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_FFMPEG_PLAYER)
 endif ()
 
+if(NOT WITH_TTS)
+    target_compile_definitions(${GOLDENDICT} PUBLIC NO_TTS_SUPPORT)
+endif()
+
 
 if (NOT WITH_EPWING_SUPPORT)
     target_compile_definitions(${GOLDENDICT} PUBLIC NO_EPWING_SUPPORT)
@@ -164,22 +189,20 @@
 
 #### add translations
 
-install(TARGETS ${GOLDENDICT}
-        BUNDLE DESTINATION .
-        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/${GOLDENDICT})
-
 # include all *ts files under locale
 file(GLOB TRANS_FILES "locale/*.ts")
 
-# Put generated files to output dir's locale
-set_source_files_properties(${TRANS_FILES}
-        PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/locale")
-
+if (WIN32)
+    # Put generated files to output dir's locale
+    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${GD_WIN_OUTPUT_DIR}/locale")
+else ()
+    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/locale")
+endif ()
 # a wrapper over qt_add_lupdate and  qt_add_lrelease
 qt_add_translations(${GOLDENDICT} TS_FILES ${TRANS_FILES}
         QM_FILES_OUTPUT_VARIABLE qm_files)
 
-#### installation
+#### installation or assemble redistribution
 
 if (APPLE)
     set_target_properties(${GOLDENDICT} PROPERTIES
@@ -191,14 +214,50 @@
 endif ()
 
 if (LINUX OR BSD)
+    install(TARGETS ${GOLDENDICT})
     install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop DESTINATION share/applications)
     install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.metainfo.xml DESTINATION share/metainfo)
 
-    install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps)
-
-    install(FILES ${qm_files} DESTINATION share/goldendict/locale)
-endif ()
-
-qt_finalize_target(${GOLDENDICT})
+    if (NOT USE_ALTERNATIVE_NAME)
+        # see: config.cc -> getProgramDataDir
+        add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict")
+        install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps)
+        install(FILES ${qm_files} DESTINATION share/goldendict/locale)
+    else ()
+        add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict-ng")
+        install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps
+                RENAME goldendict-ng.png)
+        install(FILES ${qm_files} DESTINATION share/goldendict-ng/locale)
+
+        block() # patch the desktop file to adapt the binary & icon file's name change
+            file(READ "${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop" DESKTOP_FILE_CONTENT)
+            string(REGEX REPLACE "\nIcon=goldendict\n" "\nIcon=goldendict-ng\n" DESKTOP_FILE_CONTENT "${DESKTOP_FILE_CONTENT}")
+            string(REGEX REPLACE "\nExec=goldendict %u\n" "\nExec=goldendict-ng %u\n" DESKTOP_FILE_CONTENT "${DESKTOP_FILE_CONTENT}")
+            file(WRITE "${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop" "${DESKTOP_FILE_CONTENT}")
+        endblock()
+    endif ()
+endif ()
+
+if (WIN32)
+    find_program(TOOL_WINDEPLOYQT NAMES windeployqt PATHS "${Qt6_ROOT}/bin")
+    set_target_properties(${GOLDENDICT}
+            PROPERTIES
+            WIN32_EXECUTABLE TRUE
+            RUNTIME_OUTPUT_DIRECTORY "${GD_WIN_OUTPUT_DIR}"
+            LIBRARY_OUTPUT_DIRECTORY "${GD_WIN_OUTPUT_DIR}"
+    )
+
+    add_custom_target(windeploy
+            COMMENT "Deploy everything to the output dir"
+            DEPENDS ${GOLDENDICT} # build this target will check if Goldendict.exe is already built
+            COMMAND ${TOOL_WINDEPLOYQT} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
+            COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_SOURCE_DIR}/opencc" "${GD_WIN_OUTPUT_DIR}/opencc"
+            COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/LICENSE.txt" "${GD_WIN_OUTPUT_DIR}/LICENSE.txt"
+            COMMAND ${CMAKE_COMMAND} -E rm -f "${GD_WIN_OUTPUT_DIR}/goldendict.exe.manifest" "${GD_WIN_OUTPUT_DIR}/eb.dll.manifest"
+            WORKING_DIRECTORY ${GD_WIN_OUTPUT_DIR}
+    )
+
+    #TODO: use CPack to make the output folder as NSIS installer
+endif ()
 
 feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-ng (23.12.26-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:52:59 +1100

goldendict-ng (23.12.26-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:52:08 +0000

goldendict-ng (23.12.26-1) unstable; urgency=medium

  * New upstream release 23.12.08-alpha.231226.619e7e00.
  * debian/copyright: Add information about mark.js.

 -- Boyuan Yang <byang@debian.org>  Wed, 27 Dec 2023 14:49:44 -0500

goldendict-ng (23.10.01-2) unstable; urgency=medium

  * debian/clean: Clean symlink created during packaging to prevent
    double-build FTBFS. (Closes: #1044294)

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Oct 2023 23:55:53 -0400

goldendict-ng (23.10.01-1) unstable; urgency=medium

  * New upstream release 23.10.01-alpha.e69aabf2.
  * debian/copyright: Update information.
  * debian/missing-sources/: Add new embedded javascripts.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Oct 2023 14:43:44 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: goldendict-ng
 Priority: optional
 Section: utils
-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
  cmake (>= 3.25),

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,10 @@
 	        $(NULL)
 
 execute_before_dh_auto_configure:
+	# Use unminified javascript sources
 	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
+	cp debian/missing-sources/popper.js src/scripts/popper.min.js
+	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js
+

## goldendict-ng 24.05.13

=== debian/changelog ===
goldendict-ng (24.05.13-5) unstable; urgency=medium

  * Rebuild against opencc 1.1.8.

 -- Boyuan Yang <byang@debian.org>  Mon, 05 Aug 2024 12:10:00 -0400

goldendict-ng (24.05.13-4) unstable; urgency=medium

  * Really fix #1073980.

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jun 2024 15:34:53 -0400

goldendict-ng (24.05.13-3) unstable; urgency=medium

  * Fix previous upload.
  * debian/source/lintian-overrides: Remove mismatch override.

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jun 2024 15:24:58 -0400

goldendict-ng (24.05.13-2) unstable; urgency=medium

  * debian/control: Add missing libqt6svg6 as runtime dependency.
    (Closes: #1073980)

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jun 2024 15:15:46 -0400

goldendict-ng (24.05.13-1) unstable; urgency=medium

  * New upstream tag 24.05.13-alpha.2e88e3b2.
  * debian/patches/backport/e2e1ca...patch: Apply upstream patch to
    fix compilation against ffmpeg 7.0. (Closes: #1072416)

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Jun 2024 14:32:37 -0400

goldendict-ng (24.05.05-1) unstable; urgency=medium

  * New upstream tag 24.05.05-LiXia.ecd1138c.
  * debian/rules: Drop flags no longer used by upstream.
  * debian/patches: Drop patches merged upstream.

 -- Boyuan Yang <byang@debian.org>  Mon, 06 May 2024 23:27:41 -0400

goldendict-ng (24.02.16-2) unstable; urgency=medium

  * d/p/e62dded0f62c143406df775b604e86cb933d92ee.patch:
    Fix reproducible-builds issue, patch from upstream. (Closes: #1068176)
  * d/rules: Clean src/scripts/jquery-3.6.0.slim.min.js in dh_clean.
    (Closes: #1044294)

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Apr 2024 14:58:09 -0400

goldendict-ng (24.02.16-1) unstable; urgency=medium

  * New upstream tag v24.02.16-alpha.fbe5335e.
  * debian/copyright: Remove info about files no longer used upstream.
  * debian/missing-sources: Ditto.
  * debian/control: Update build-dependencies: pkg-config => pkgconf.

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Apr 2024 23:03:20 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: goldendict-ng
 Priority: optional
 Section: utils
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Boyuan Yang <byang@debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
  cmake (>= 3.25),
@@ -16,14 +15,14 @@
  libjs-jquery,
  liblzma-dev,
  liblzo2-dev,
- libopencc-dev (>= 1.1),
+ libopencc-dev (>= 1.1.8~),
  libtomlplusplus-dev,
  libvorbis-dev,
  libx11-dev,
  libxtst-dev,
  libzim-dev,
  libzstd-dev,
- pkg-config,
+ pkgconf,
  qt6-5compat-dev,
  qt6-base-dev,
  qt6-multimedia-dev,
@@ -44,6 +43,7 @@
 Architecture: any
 Depends:
  libjs-jquery,
+ libqt6svg6,
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,11 @@
 %:
 	dh $@ --buildsystem=cmake
 
+execute_after_dh_clean:
+	rm -fv src/scripts/jquery-3.6.0.slim.min.js
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	        -DWITH_XAPIAN=ON \
 	        -DWITH_ZIM=ON \
 	        -DWITH_FFMPEG_PLAYER=ON \
 	        -DWITH_EPWING_SUPPORT=ON \
@@ -25,6 +27,4 @@
 	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
-	cp debian/missing-sources/popper.js src/scripts/popper.min.js
-	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js

## goldendict-ng 25.02.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25) # Debian 11 Ubuntu 24.04 Fedora 36

option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
option(WITH_ZIM "enable zim support" ON)
option(WITH_TTS "enable QTexttoSpeech support" OFF)

# options for linux packaging
option(USE_SYSTEM_FMT "use system fmt instead of bundled one" OFF)
option(USE_SYSTEM_TOML "use system toml++ instead of bundled one" OFF)

## This should be avoided because of small regressions, as some scripts and icons themes assume the binary name and resources folder to be `goldendict`
option(USE_ALTERNATIVE_NAME "For Linux, change the binary name and resource folder to goldendict-ng to parallel install with the original GD" OFF)

# vcpkg handling code, must be placed before project()
if (WIN32)
    option(WITH_VCPKG_BREAKPAD "build with Breakpad support for VCPKG build only" OFF)
    if (DEFINED CMAKE_TOOLCHAIN_FILE)
        message(STATUS "Using toolchain file: ${CMAKE_TOOLCHAIN_FILE}")
    else ()
        message(STATUS "CMAKE_TOOLCHAIN_FILE is not set. Try fetching cached vcpkg.")
        include(FetchContent)
        FetchContent_Declare(
                vcpkg-export
                URL https://github.com/xiaoyifang/goldendict-ng/releases/download/vcpkg_250123_b588ddc8230705392c53448597f5892966a8db15/goldendict-ng-vcpkg-export.tar.zst
                URL_HASH SHA512=E8286C6C08BEE93F01E63A1BEAAC0FD88157B9F3AD7C2AABC172BD2F33834AF08A07321AB1823AD167DA4F82320DCE0EC56C75BB19A38402831D126068F8888E
        )
        FetchContent_MakeAvailable(vcpkg-export)
        set(VCPKG_MANIFEST_MODE OFF CACHE BOOL "disable existing manifest mode caused by the existrance of vcpkg.json" FORCE)
        set(CMAKE_TOOLCHAIN_FILE "${CMAKE_BINARY_DIR}/_deps/vcpkg-export-src/scripts/buildsystems/vcpkg.cmake")
    endif ()
    if (WITH_VCPKG_BREAKPAD)
        list(APPEND VCPKG_MANIFEST_FEATURES "breakpad")
    endif ()
endif ()

include(FeatureSummary)

project(goldendict-ng
        VERSION 25.02.0
        LANGUAGES CXX C)

if (APPLE)
    enable_language(OBJCXX)
    set(CMAKE_OBJCXX_STANDARD 17)
endif ()

set(CMAKE_C_STANDARD 17)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(GOLDENDICT "goldendict") # binary/executable name
if (USE_ALTERNATIVE_NAME)
    set(GOLDENDICT "goldendict-ng")
endif ()
if (APPLE)
    set(GOLDENDICT "GoldenDict-ng")
endif ()

#### Qt

set(GD_QT_COMPONENTS Concurrent Core5Compat LinguistTools Multimedia PrintSupport WebEngineWidgets Widgets Svg Xml)

if (WITH_TTS)
    list(APPEND GD_QT_COMPONENTS TextToSpeech)
endif ()

find_package(Qt6 REQUIRED COMPONENTS ${GD_QT_COMPONENTS})

qt_standard_project_setup()
set(CMAKE_AUTORCC ON) # not included in the qt_standard_project_setup

#### Things required during configuration
block() # generate version.txt
    string(TIMESTAMP build_time UTC)
    find_package(Git)
    if (EXISTS "${CMAKE_SOURCE_DIR}/.git" AND GIT_FOUND)
        execute_process(
                COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_SOURCE_DIR}" rev-parse --short HEAD
                OUTPUT_STRIP_TRAILING_WHITESPACE
                OUTPUT_VARIABLE GIT_HASH)
        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION}.${GIT_HASH} at ${build_time}")
    else () # not built in a git repo
        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION} at ${build_time}")
    endif ()
endblock()

if (WIN32)
    # Binaries output dir for windows. The default ${CMAKE_BINARY_DIR} is too messy, use subfolder instead
    # So that we can directly use windeployqt inside the output folder and obtain a redistributable GD
    set(GD_WIN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/${GOLDENDICT})
endif ()

#### Sources Files

# auto discovery of ui files https://cmake.org/cmake/help/v3.26/prop_tgt/AUTOUIC_SEARCH_PATHS.html
set(CMAKE_AUTOUIC_SEARCH_PATHS "${CMAKE_CURRENT_SOURCE_DIR}/src/ui/")

# https://cmake.org/cmake/help/latest/command/file.html#filesystem
# ! Using GLOB_RECURSE is not recommended by cmake's documentation
# CONFIGURE_DEPENDS will trigger file tree recheck in every rebuilds.
file(GLOB_RECURSE ALL_SOURCE_FILES CONFIGURE_DEPENDS src/*.cc src/*.hh src/*.ui src/*.c)

if (APPLE)
    file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)

    set(MACOS_APP_ICON ${CMAKE_SOURCE_DIR}/icons/macicon.icns)
    set_source_files_properties(${MACOS_APP_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
endif ()

if (WIN32)
    set(WINDOWS_ICON_RC icons/programicon.rc)
endif ()

set(QSINGLEAPP_SOURCE_FILES
        thirdparty/qtsingleapplication/src/qtlocalpeer.cpp
        thirdparty/qtsingleapplication/src/qtlocalpeer.h
        thirdparty/qtsingleapplication/src/qtsingleapplication.cpp
        thirdparty/qtsingleapplication/src/qtsingleapplication.h
)

qt_add_executable(${GOLDENDICT})

target_sources(${GOLDENDICT} PRIVATE
        icons/flags.qrc
        resources.qrc
        src/scripts/scripts.qrc
        src/stylesheets/css.qrc
        ${ALL_SOURCE_FILES}
        ${MACOS_SOURCE_FILES}
        ${MACOS_APP_ICON}
        ${QSINGLEAPP_SOURCE_FILES}
        ${WINDOWS_ICON_RC}
)

if (NOT USE_SYSTEM_FMT)
    target_sources(${GOLDENDICT} PRIVATE thirdparty/fmt/format.cc)
endif ()

### Common parts amount all platforms

# Note: used as c++ string thus need surrounding " "
add_compile_definitions(PROGRAM_VERSION="${PROJECT_VERSION}")

target_link_libraries(${GOLDENDICT} PRIVATE
        Qt6::Xml
        Qt6::Concurrent
        Qt6::Core5Compat
        Qt6::Multimedia
        Qt6::PrintSupport
        Qt6::WebEngineWidgets
        Qt6::Widgets
        Qt6::Svg
        $<$<BOOL:${WITH_TTS}>:Qt6::TextToSpeech>
)

target_include_directories(${GOLDENDICT} PRIVATE
        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
        ${PROJECT_SOURCE_DIR}/src/
        ${PROJECT_SOURCE_DIR}/src/common
        ${PROJECT_SOURCE_DIR}/src/dict
        ${PROJECT_SOURCE_DIR}/src/dict/utils
        ${PROJECT_SOURCE_DIR}/src/ui
)

if (NOT USE_SYSTEM_TOML)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/tomlplusplus)
endif ()

if (NOT USE_SYSTEM_FMT)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/fmt/include)
endif ()

#### Compile definitions

# Disable deprecated staffs for Qt<=6.7 (Bump this if ever consider bump Qt version)
target_compile_definitions(${GOLDENDICT} PRIVATE
        QT_DISABLE_DEPRECATED_UP_TO=0x060700
        QT_NO_DEPRECATED_WARNINGS
)

target_compile_definitions(${GOLDENDICT} PUBLIC
        MAKE_QTMULTIMEDIA_PLAYER
        MAKE_CHINESE_CONVERSION_SUPPORT
        $<$<BOOL:${WIN32}>:__WIN32>
        $<$<BOOL:${WITH_FFMPEG_PLAYER}>:MAKE_FFMPEG_PLAYER>
        $<$<BOOL:${WITH_TTS}>:TTS_SUPPORT>
        $<$<BOOL:${WITH_EPWING_SUPPORT}>:EPWING_SUPPORT>
        $<$<BOOL:${WITH_ZIM}>:MAKE_ZIM_SUPPORT>
        $<$<BOOL:${WITH_VCPKG_BREAKPAD}>:USE_BREAKPAD>
)

#### libraries linking && includes for Win or Unix

if (WIN32)
    include(cmake/Deps_Vcpkg.cmake)
else ()
    include(cmake/Deps_Unix.cmake)
endif ()

#### add translations

# include all *ts files under locale
file(GLOB TRANS_FILES "locale/*.ts")

if (WIN32)
    # Put generated files to output dir's locale
    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${GD_WIN_OUTPUT_DIR}/locale")
else ()
    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/locale")
endif ()

qt_add_translations(${GOLDENDICT} TS_FILES ${TRANS_FILES}
        QM_FILES_OUTPUT_VARIABLE qm_files
        LUPDATE_OPTIONS "-no-ui-lines -locations none -no-obsolete")

add_dependencies(${GOLDENDICT} "release_translations")

#### installation or assemble redistribution

if (APPLE)
    include(cmake/Package_macOS.cmake)
elseif (LINUX OR BSD)
    include(cmake/Package_Linux.cmake)
elseif (WIN32)
    include(cmake/Package_Windows.cmake)
endif ()

feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-ng (25.02.0-2) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Jan 2025 09:51:25 -0500

goldendict-ng (25.02.0-2~exp1) experimental; urgency=medium

  * QA upload.
  * debian/control: Add new transitional binary package goldendict
    to transit from old qtwebkit-based goldendict to the goldendict-ng
    implementation. (See #1093551)
  * debian/rules: Hack dh_gencontrol to keep a lower version string
    for the goldendict binary package.
  * debian/goldendict-ng.install: Added.

 -- Boyuan Yang <byang@debian.org>  Fri, 24 Jan 2025 22:17:38 -0500

goldendict-ng (25.02.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/patches/0001-Disable-checkUpdate-by-default.patch: Refreshed.
  * debian/copyright: Updated.

 -- Boyuan Yang <byang@debian.org>  Fri, 24 Jan 2025 21:53:41 -0500

goldendict-ng (24.09.1-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package. (See #1093568)

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Jan 2025 18:39:27 -0500

goldendict-ng (24.09.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild against libzim9
  * Depends on qt6-svg-plugins insteaf of only libqt6svg6 (Closes: #1090756)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 11 Jan 2025 22:36:38 +0100

goldendict-ng (24.09.1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Nov 2024 17:28:22 -0500

goldendict-ng (24.09.0-2) unstable; urgency=high

  * debian/copyright: Fix typo.
  * Rebuild against Qt 6.7.2 to fix crashing. (Closes: #1084759)

 -- Boyuan Yang <byang@debian.org>  Tue, 08 Oct 2024 12:39:44 -0400

goldendict-ng (24.09.0-1) unstable; urgency=medium

  * New upstream tag v24.09.0-Release.316ec900.
  * debian/copyright: Update information.
  * debian/patches/backport/*: Drop backported patches.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Sep 2024 16:48:51 -0400

goldendict-ng (24.05.13-6) unstable; urgency=medium

  * Rebuild against opencc 1.1.9.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Aug 2024 16:48:34 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: goldendict-ng
 Priority: optional
 Section: utils
-Maintainer: Boyuan Yang <byang@debian.org>
-Standards-Version: 4.6.2
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Standards-Version: 4.7.0
 Build-Depends:
  cmake (>= 3.25),
  debhelper-compat (= 13),
@@ -15,12 +15,12 @@
  libjs-jquery,
  liblzma-dev,
  liblzo2-dev,
- libopencc-dev (>= 1.1.8~),
+ libopencc-dev (>= 1.1.9~),
  libtomlplusplus-dev,
  libvorbis-dev,
  libx11-dev,
  libxtst-dev,
- libzim-dev,
+ libzim-dev (>= 9.1.0),
  libzstd-dev,
  pkgconf,
  qt6-5compat-dev,
@@ -43,14 +43,14 @@
 Architecture: any
 Depends:
  libjs-jquery,
- libqt6svg6,
+ qt6-svg-plugins,
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
- goldendict,
+ goldendict (<< 1.5.0+git20241211+rm~),
  goldendict-webengine,
 Replaces:
- goldendict,
+ goldendict (<< 1.5.0+git20241211+rm~),
  goldendict-webengine,
 Provides:
  goldendict,
@@ -64,3 +64,12 @@
  .
  This is a forked version that uses QtWebEngine as rendering engine instead
  of QtWebKit.
+
+Package: goldendict
+Architecture: all
+Section: oldlibs
+Depends:
+ goldendict-ng,
+ ${misc:Depends},
+Description: transitional package
+ This is a transitional package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,13 @@
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export QT_SELECT := 6
+
+include /usr/share/dpkg/default.mk
+
+# For transition from goldendict to goldendict-ng
+# see https://bugs.debian.org/1093551
+VERSION_GOLDENDICT = 1.5.0+git20241211+rm
+_DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
 
 %:
 	dh $@ --buildsystem=cmake
@@ -28,3 +35,6 @@
 	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
 
+override_dh_gencontrol:
+	dh_gencontrol -pgoldendict -- -v$(VERSION_GOLDENDICT)-$(_DEB_VERSION_REVISION)
+	dh_gencontrol --remaining-packages

## goldendict-ng 25.06.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,7 +37,7 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 25.02.0
+        VERSION 25.06.0
         LANGUAGES CXX C)
 
 if (APPLE)
@@ -179,6 +179,13 @@
         QT_NO_DEPRECATED_WARNINGS
 )
 
+# make life harder https://doc.qt.io/qt-6/qtglobal.html#QT_ENABLE_STRICT_MODE_UP_TO
+if (Qt6Widgets_VERSION VERSION_GREATER_EQUAL 6.8.2)
+    target_compile_definitions(${GOLDENDICT} PRIVATE
+            QT_ENABLE_STRICT_MODE_UP_TO=0x060800
+    )
+endif ()
+
 target_compile_definitions(${GOLDENDICT} PUBLIC
         MAKE_QTMULTIMEDIA_PLAYER
         MAKE_CHINESE_CONVERSION_SUPPORT

=== debian/changelog ===
goldendict-ng (25.06.0-2) unstable; urgency=medium

  * QA upload.
  * debian/rules: Bump hardcoded version string for goldendict package.
    (Closes: #1102515)
  * debian/control: Bump Standards-Version to 4.7.2.

 -- Boyuan Yang <byang@debian.org>  Wed, 09 Apr 2025 17:59:48 -0400

goldendict-ng (25.06.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 09 Apr 2025 09:40:34 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Section: utils
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends:
  cmake (>= 3.25),
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 # For transition from goldendict to goldendict-ng
 # see https://bugs.debian.org/1093551
-VERSION_GOLDENDICT = 1.5.0+git20241211+rm
+VERSION_GOLDENDICT = 1.5.0+git20250409+rm
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
 
 %:

## goldendict-ng 25.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,12 @@
 cmake_minimum_required(VERSION 3.25) # Debian 11 Ubuntu 24.04 Fedora 36
 
-option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
+option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player. Note: This is useless for Qt >= 6.8" ON)
+option(WITH_QT_MULTIMEDIA "Enable support for Qt Multimedia player" ON)
 option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
 option(WITH_ZIM "enable zim support" ON)
 option(WITH_TTS "enable QTexttoSpeech support" OFF)
+
+option(WITH_X11 "Experimental flag. Don't disable this. Disable means pure Wayland." ON)
 
 # options for linux packaging
 option(USE_SYSTEM_FMT "use system fmt instead of bundled one" OFF)
@@ -37,7 +40,7 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 25.06.0
+        VERSION 25.10.1
         LANGUAGES CXX C)
 
 if (APPLE)
@@ -102,7 +105,7 @@
 file(GLOB_RECURSE ALL_SOURCE_FILES CONFIGURE_DEPENDS src/*.cc src/*.hh src/*.ui src/*.c)
 
 if (APPLE)
-    file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
+    file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/**/*.mm)
 
     set(MACOS_APP_ICON ${CMAKE_SOURCE_DIR}/icons/macicon.icns)
     set_source_files_properties(${MACOS_APP_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
@@ -187,24 +190,16 @@
 endif ()
 
 target_compile_definitions(${GOLDENDICT} PUBLIC
-        MAKE_QTMULTIMEDIA_PLAYER
         MAKE_CHINESE_CONVERSION_SUPPORT
         $<$<BOOL:${WIN32}>:__WIN32>
         $<$<BOOL:${WITH_FFMPEG_PLAYER}>:MAKE_FFMPEG_PLAYER>
+        $<$<BOOL:${WITH_QT_MULTIMEDIA}>:MAKE_QTMULTIMEDIA_PLAYER>
         $<$<BOOL:${WITH_TTS}>:TTS_SUPPORT>
         $<$<BOOL:${WITH_EPWING_SUPPORT}>:EPWING_SUPPORT>
         $<$<BOOL:${WITH_ZIM}>:MAKE_ZIM_SUPPORT>
         $<$<BOOL:${WITH_VCPKG_BREAKPAD}>:USE_BREAKPAD>
 )
 
-#### libraries linking && includes for Win or Unix
-
-if (WIN32)
-    include(cmake/Deps_Vcpkg.cmake)
-else ()
-    include(cmake/Deps_Unix.cmake)
-endif ()
-
 #### add translations
 
 # include all *ts files under locale
@@ -223,14 +218,17 @@
 
 add_dependencies(${GOLDENDICT} "release_translations")
 
-#### installation or assemble redistribution
-
-if (APPLE)
-    include(cmake/Package_macOS.cmake)
-elseif (LINUX OR BSD)
+#### Dependencies and Packaging (Don't unify them. They have little in common!)
+
+if (LINUX OR BSD)
+    include(cmake/Deps_Linux.cmake)
     include(cmake/Package_Linux.cmake)
 elseif (WIN32)
+    include(cmake/Deps_Vcpkg.cmake)
     include(cmake/Package_Windows.cmake)
+else ()
+    include(cmake/Deps_macOS.cmake)
+    include(cmake/Package_macOS.cmake)
 endif ()
 
 feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-ng (25.10.1-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/control: Move package description to the source package section.
  * debian/watch: Update to version 5.
  * debian/copyright: Refresh information.
  * debian/upstream/metadata: Updated.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Oct 2025 12:23:40 -0400

## goldendict-ng 25.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 25.10.1
+        VERSION 25.10.2
         LANGUAGES CXX C)
 
 if (APPLE)

=== debian/changelog ===
goldendict-ng (25.10.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 11 Oct 2025 17:49:10 -0400

=== debian/control ===
--- 
+++ 
@@ -38,6 +38,15 @@
 Homepage: https://github.com/xiaoyifang/goldendict-ng
 Vcs-Browser: https://salsa.debian.org/debian/goldendict-ng
 Vcs-Git: https://salsa.debian.org/debian/goldendict-ng.git
+Description: feature-rich dictionary lookup program (NG/qtwebengine fork)
+ GoldenDict is a feature-rich dictionary lookup program, supporting multiple
+ dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
+ and online dictionaries, featuring perfect article rendering with the
+ complete markup, illustrations and other content retained,
+ and allowing you to type in words without any accents or correct case.
+ .
+ This is a forked version that uses QtWebEngine as rendering engine instead
+ of QtWebKit.
 
 Package: goldendict-ng
 Architecture: any
@@ -55,15 +64,8 @@
 Provides:
  goldendict,
  goldendict-webengine,
-Description: feature-rich dictionary lookup program (NG/qtwebengine fork)
- GoldenDict is a feature-rich dictionary lookup program, supporting multiple
- dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
- and online dictionaries, featuring perfect article rendering with the
- complete markup, illustrations and other content retained,
- and allowing you to type in words without any accents or correct case.
- .
- This is a forked version that uses QtWebEngine as rendering engine instead
- of QtWebKit.
+Description: ${source:Synopsis}
+ ${source:Extended-Description}
 
 Package: goldendict
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,16 @@
 export QT_SELECT := 6
 
 include /usr/share/dpkg/default.mk
+# for SOURCE_DATE_EPOCH
+include /usr/share/dpkg/pkg-info.mk
 
 # For transition from goldendict to goldendict-ng
 # see https://bugs.debian.org/1093551
-VERSION_GOLDENDICT = 1.5.0+git20250409+rm
+#
+# To ensure ascending version string, use the date from
+# SOURCE_DATE_EPOCH. See https://bugs.debian.org/1096751
+_VERSION_DATE := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +%Y%m%d)
+VERSION_GOLDENDICT = 1.5.0+git$(_VERSION_DATE)+rm
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
 
 %:

=== debian/watch ===
Version: 5

Source: https://github.com/xiaoyifang/goldendict-ng/tags
Matching-Pattern: (?:.*?/)?v?(\d+\.\d+\.\d+)-Release\.\w+@ARCHIVE_EXT@
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%
Repack: yes
Uversionmangle: s/-Release\.\w+$//
